package jtaDiscRack.business;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction; 

public class StaticXaTransactionSupport {

	/**
	 * Transaction object reference
	 */
	protected static UserTransaction transaction = null;

	/**
	 * Method initializes DB transation instance
	 */
	protected static void initTransaction() throws JtaDiscRackBusinessException {
		try {
			Context ctx = new InitialContext();
			transaction = (UserTransaction) ctx
					.lookup("java:comp/UserTransaction");
			if (transaction != null) {
				transaction.begin();
			}
		} catch (Exception ex) {
			throw new JtaDiscRackBusinessException(
					"Problems with UserTransaction begining!", ex);
		}
	}

	/**
	 * Method commits DB transation instance
	 */
	protected static void commitTransaction() throws JtaDiscRackBusinessException {
		try {
			if (transaction != null) {
				transaction.commit();
			}
		} catch (Exception ex) {
			throw new JtaDiscRackBusinessException(
					"Problems with UserTransaction commit!", ex);
		}

	}

	protected static void rollbackTransaction() throws JtaDiscRackBusinessException {
		try {
			if (transaction != null) {
				transaction.rollback();
			}
		} catch (Exception ex) {
			throw new JtaDiscRackBusinessException(
					"Problems with UserTransaction roolback!", ex);
		}
	}

}
