package jtaDiscRack.presentation.dpanels;

import jtaDiscRack.presentation.delements.*;

import javax.swing.*;
import java.awt.*;

/**
 * Creates titled group panel with vertical or horizontal BoxLayout,
 * that consists of panels of given elements.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class DGroupPanel extends DPanel{

   public DGroupPanel (DSimpleElement myOwner,Object[] elements,String title,
      boolean isVertical,boolean hasBorder) {

      super(myOwner,elements.length+1,title,isVertical,hasBorder);

      DPanel dtdp=null;
      for (int i=0; i<elements.length; i++) {
         if (elements[i] instanceof DSimpleElement) {
            dtdp=((DSimpleElement)elements[i]).getPanel();
         } else if (elements[i] instanceof DPanel) {
            dtdp=(DPanel)elements[i];
         }
         dtdp.setEnabled(!myOwner.isReadOnly());
         add(dtdp);
      }

      if (isVertical) {
         add(Box.createVerticalGlue());
      }
      else {
         add(Box.createHorizontalGlue());
      }

   }

   public DPanel getPanel (int no) {
      if (no>=getComponentCount()-1) {
         return null;
      }
      return (DPanel)getComponent(no);
   }

   public boolean checkRequired () {
      if (isEmpty() && !getOwner().isRequired()) return true;
      boolean isOK=true;
      for (int i=0; i<getComponentCount();i++) {
         Component c=getComponent(i);
         if (c instanceof DPanel) {
            isOK=isOK && ((DPanel)c).checkRequired();
         }
      }
      return isOK;
   }

   public boolean isEmpty () {
      boolean isEmpty=true;
      for (int i=0; i<getComponentCount();i++) {
         Component c=getComponent(i);
         if (c instanceof DPanel) {
            isEmpty=isEmpty && ((DPanel)c).isEmpty();
         }
      }
      return isEmpty;
   }

   public void setElements () {
      for (int i=0; i<getComponentCount();i++) {
         Component c=getComponent(i);
         if (c instanceof DPanel) {
            ((DPanel)c).setElements();
         }
      }
   }

}
